//////////////////////////////////////////////////////////////////////////////
//                                      //
//  Gateway con IP fija         //
//  Hardware: - Arduino MEGA 2560                     //
//        - Shield Ethernet W5100                   //
//                                      //
//////////////////////////////////////////////////////////////////////////////

// Let the IDE point to the Souliss framework
#include "SoulissFramework.h"


#include "bconf/StandardArduino.h"      // Use a standard Arduino
#include "conf/ethW5100.h"              // Ethernet through Wiznet W5100
#include "conf/Gateway.h"       // The main node is the Gateway, we have just one node
#include "conf/DynamicAddressing.h"     // Use dynamic address

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#include <SimpleModbusMaster.h>
#define baud 19200
#define modbusM_timeout 1000
#define modbusM_polling 200 // the scan rate
#define modbusM_retry_count 5
// used to toggle the receive/transmit pin on the driver
#define TxEnablePin 2 
// The total amount of available memory on the master to store data
#define TOTAL_NO_OF_REGISTERS 4

// This is the easiest way to create new packets
// Add as many as you want. TOTAL_NO_OF_PACKETS
// is automatically updated.
enum
{
  PACKET1,
  TOTAL_NO_OF_PACKETS // leave this last entry
};

// Create an array of Packets to be configured
modbusM_Packet packets[TOTAL_NO_OF_PACKETS];

// Masters register array
unsigned int regs[TOTAL_NO_OF_REGISTERS];

///////////////////////////////////////////////////////////////////////////////////////////////////////////



#include <SPI.h>
#include <EEPROM.h>
#include <Souliss.h>

uint8_t ip_address[4] = { 192,168,1,50 }; // 
uint8_t subnet_mask[4] = { 255,255,255,0 };
uint8_t ip_gateway[4] = { 192,168,1,1 };

#define myvNet_address  ip_address[3]       // The last byte of the IP address (50) is also the vNet address
#define myvNet_subnet   0xFF00
#define myvNet_supern 0x0000

// Analog Measurements/Sensors (T5n)
#define SLOT_T55  0 // Voltage(0, 400) V                - 2 Slot


void setup()
{
  Serial.begin(9600);
  Initialize();
  Souliss_SetAddress(myvNet_address, myvNet_subnet, myvNet_supern);
  SetAsGateway(myvNet_address);
  SetAddressingServer();  

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  modbusM_construct(&packets[PACKET1], 5, READ_HOLDING_REGISTERS, 4096, 2, 0);//ID, Function  , Address,   data_lenght, local variable start adress
 // modbusM_construct(&packets[PACKET2], 1, PRESET_MULTIPLE_REGISTERS, 1, 1, 1);
 // modbusM_packet_Once(packets[PACKET2]);
  modbusM_enable_retriesForever(packets[PACKET1]);

  
  // Initialize the Modbus Finite State Machine
  modbusM_configure(&Serial3, baud, SERIAL_8E1, modbusM_timeout, modbusM_polling, modbusM_retry_count, TxEnablePin, packets, TOTAL_NO_OF_PACKETS, regs);
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


//define typicals
 Set_T55(SLOT_T55);
 
}
 
void loop()
{
  EXECUTEFAST()
  {
    UPDATEFAST();
      
    FAST_510ms()
    {
      //Logic_T55(SLOT_T55);
      Souliss_Logic_T55(memory_map, SLOT_T55, 0.005, &data_changed);
       modbusM_update();
    }

    FAST_910ms()
    {
      long milivolts= (long)regs[0] *0xFFFF + regs[1];
      float voltage=(float)milivolts/1000;
      ImportAnalog(SLOT_T55, &voltage);



    }

    FAST_GatewayComms();
  }
}
